#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: Transient Response
# Author: HARSHAL
# Generated: Fri May 22 16:26:38 2015
##################################################

from gnuradio import eng_notation
from gnuradio import gr
from gnuradio.eng_option import eng_option
from gnuradio.gr import firdes
from gnuradio.wxgui import forms
from gnuradio.wxgui import numbersink2
from grc_gnuradio import wxgui as grc_wxgui
from optparse import OptionParser
import gnuradio.input.Calculator
import gnuradio.input.Denominator
import gnuradio.input.Max_val
import gnuradio.input.Numerator
import gnuradio.input.Response
import gnuradio.input.plot_sink
import wx

class top_block(grc_wxgui.top_block_gui):

	def __init__(self):
		grc_wxgui.top_block_gui.__init__(self, title="Transient Response")

		##################################################
		# Variables
		##################################################
		self.variable_slider_5 = variable_slider_5 = 4
		self.variable_slider_4 = variable_slider_4 = 2
		self.variable_slider_3 = variable_slider_3 = 0.4
		self.variable_slider_2 = variable_slider_2 = 0.121
		self.variable_slider_1 = variable_slider_1 = 6.2
		self.variable_slider_0 = variable_slider_0 = 1.33
		self.samp_rate = samp_rate = 1

		##################################################
		# Blocks
		##################################################
		_variable_slider_5_sizer = wx.BoxSizer(wx.VERTICAL)
		self._variable_slider_5_text_box = forms.text_box(
			parent=self.GetWin(),
			sizer=_variable_slider_5_sizer,
			value=self.variable_slider_5,
			callback=self.set_variable_slider_5,
			label="Actual parameter N",
			converter=forms.float_converter(),
			proportion=0,
		)
		self._variable_slider_5_slider = forms.slider(
			parent=self.GetWin(),
			sizer=_variable_slider_5_sizer,
			value=self.variable_slider_5,
			callback=self.set_variable_slider_5,
			minimum=0,
			maximum=10,
			num_steps=10,
			style=wx.SL_HORIZONTAL,
			cast=float,
			proportion=1,
		)
		self.GridAdd(_variable_slider_5_sizer, 1, 2, 1, 1)
		_variable_slider_4_sizer = wx.BoxSizer(wx.VERTICAL)
		self._variable_slider_4_text_box = forms.text_box(
			parent=self.GetWin(),
			sizer=_variable_slider_4_sizer,
			value=self.variable_slider_4,
			callback=self.set_variable_slider_4,
			label="Initial Height of magnet yo",
			converter=forms.float_converter(),
			proportion=0,
		)
		self._variable_slider_4_slider = forms.slider(
			parent=self.GetWin(),
			sizer=_variable_slider_4_sizer,
			value=self.variable_slider_4,
			callback=self.set_variable_slider_4,
			minimum=1.50000,
			maximum=2.50000,
			num_steps=1000,
			style=wx.SL_HORIZONTAL,
			cast=float,
			proportion=1,
		)
		self.GridAdd(_variable_slider_4_sizer, 1, 3, 1, 1)
		_variable_slider_3_sizer = wx.BoxSizer(wx.VERTICAL)
		self._variable_slider_3_text_box = forms.text_box(
			parent=self.GetWin(),
			sizer=_variable_slider_3_sizer,
			value=self.variable_slider_3,
			callback=self.set_variable_slider_3,
			label="Viscous Friction Coefficient c",
			converter=forms.float_converter(),
			proportion=0,
		)
		self._variable_slider_3_slider = forms.slider(
			parent=self.GetWin(),
			sizer=_variable_slider_3_sizer,
			value=self.variable_slider_3,
			callback=self.set_variable_slider_3,
			minimum=0.30000,
			maximum=0.50000,
			num_steps=1000,
			style=wx.SL_HORIZONTAL,
			cast=float,
			proportion=1,
		)
		self.GridAdd(_variable_slider_3_sizer, 0, 3, 1, 1)
		_variable_slider_2_sizer = wx.BoxSizer(wx.VERTICAL)
		self._variable_slider_2_text_box = forms.text_box(
			parent=self.GetWin(),
			sizer=_variable_slider_2_sizer,
			value=self.variable_slider_2,
			callback=self.set_variable_slider_2,
			label="Magnet mass m",
			converter=forms.float_converter(),
			proportion=0,
		)
		self._variable_slider_2_slider = forms.slider(
			parent=self.GetWin(),
			sizer=_variable_slider_2_sizer,
			value=self.variable_slider_2,
			callback=self.set_variable_slider_2,
			minimum=0.09075,
			maximum=0.15125,
			num_steps=1000,
			style=wx.SL_HORIZONTAL,
			cast=float,
			proportion=1,
		)
		self.GridAdd(_variable_slider_2_sizer, 0, 2, 1, 1)
		_variable_slider_1_sizer = wx.BoxSizer(wx.VERTICAL)
		self._variable_slider_1_text_box = forms.text_box(
			parent=self.GetWin(),
			sizer=_variable_slider_1_sizer,
			value=self.variable_slider_1,
			callback=self.set_variable_slider_1,
			label="Actuator Coefficient b",
			converter=forms.float_converter(),
			proportion=0,
		)
		self._variable_slider_1_slider = forms.slider(
			parent=self.GetWin(),
			sizer=_variable_slider_1_sizer,
			value=self.variable_slider_1,
			callback=self.set_variable_slider_1,
			minimum=4.65000,
			maximum=7.75000,
			num_steps=1000,
			style=wx.SL_HORIZONTAL,
			cast=float,
			proportion=1,
		)
		self.GridAdd(_variable_slider_1_sizer, 1, 1, 1, 1)
		_variable_slider_0_sizer = wx.BoxSizer(wx.VERTICAL)
		self._variable_slider_0_text_box = forms.text_box(
			parent=self.GetWin(),
			sizer=_variable_slider_0_sizer,
			value=self.variable_slider_0,
			callback=self.set_variable_slider_0,
			label="Actuator Coefficient a",
			converter=forms.float_converter(),
			proportion=0,
		)
		self._variable_slider_0_slider = forms.slider(
			parent=self.GetWin(),
			sizer=_variable_slider_0_sizer,
			value=self.variable_slider_0,
			callback=self.set_variable_slider_0,
			minimum=0.9975,
			maximum=1.6625,
			num_steps=1000,
			style=wx.SL_HORIZONTAL,
			cast=float,
			proportion=1,
		)
		self.GridAdd(_variable_slider_0_sizer, 0, 1, 1, 1)
		self.notebook_0 = self.notebook_0 = wx.Notebook(self.GetWin(), style=wx.NB_TOP)
		self.notebook_0.AddPage(grc_wxgui.Panel(self.notebook_0), "Inputs")
		self.notebook_0.AddPage(grc_wxgui.Panel(self.notebook_0), "Plot")
		self.notebook_0.AddPage(grc_wxgui.Panel(self.notebook_0), "Parameter")
		self.Add(self.notebook_0)
		self.wxgui_numbersink2_3 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(0).GetWin(),
			unit="S",
			minval=-100,
			maxval=100,
			factor=1.0,
			decimal_places=5,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="Coeff. S",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(0).GridAdd(self.wxgui_numbersink2_3.win, 5, 2, 1, 1)
		self.wxgui_numbersink2_2 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(0).GetWin(),
			unit="S^2",
			minval=-100,
			maxval=100,
			factor=1.0,
			decimal_places=0,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="Coeff. S^2",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(0).GridAdd(self.wxgui_numbersink2_2.win, 5, 1, 1, 1)
		self.wxgui_numbersink2_1 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(0).GetWin(),
			unit="",
			minval=-100,
			maxval=100,
			factor=1.0,
			decimal_places=5,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="r",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(0).GridAdd(self.wxgui_numbersink2_1.win, 5, 3, 1, 1)
		self.wxgui_numbersink2_0_5 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(0).GetWin(),
			unit="",
			minval=-1000,
			maxval=1000,
			factor=1.0,
			decimal_places=5,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="q",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(0).GridAdd(self.wxgui_numbersink2_0_5.win, 4, 2, 1, 1)
		self.wxgui_numbersink2_0_4 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(2).GetWin(),
			unit="s",
			minval=-100,
			maxval=100,
			factor=1.0,
			decimal_places=8,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="Peak Value",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(2).GridAdd(self.wxgui_numbersink2_0_4.win, 3, 2, 1, 1)
		self.wxgui_numbersink2_0_3 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(2).GetWin(),
			unit="%",
			minval=-100,
			maxval=100,
			factor=1.0,
			decimal_places=3,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="Overshoot(%)",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(2).GridAdd(self.wxgui_numbersink2_0_3.win, 1, 2, 1, 1)
		self.wxgui_numbersink2_0_2 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(2).GetWin(),
			unit="",
			minval=-100,
			maxval=100,
			factor=1.0,
			decimal_places=6,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="Steady-State Gain",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(2).GridAdd(self.wxgui_numbersink2_0_2.win, 2, 2, 1, 1)
		self.wxgui_numbersink2_0_1 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(2).GetWin(),
			unit="s",
			minval=-100,
			maxval=100,
			factor=1.0,
			decimal_places=3,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="Settling Time(Ts)",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(2).GridAdd(self.wxgui_numbersink2_0_1.win, 3, 1, 1, 1)
		self.wxgui_numbersink2_0_0 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(2).GetWin(),
			unit="s",
			minval=-100,
			maxval=100,
			factor=1.0,
			decimal_places=3,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="Peak Time(Tp)",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(2).GridAdd(self.wxgui_numbersink2_0_0.win, 2, 1, 1, 1)
		self.wxgui_numbersink2_0 = numbersink2.number_sink_f(
			self.notebook_0.GetPage(2).GetWin(),
			unit="s",
			minval=-100,
			maxval=100,
			factor=1.0,
			decimal_places=3,
			ref_level=0,
			sample_rate=samp_rate,
			number_rate=15,
			average=False,
			avg_alpha=None,
			label="Rise Time(Tr)",
			peak_hold=False,
			show_gauge=True,
		)
		self.notebook_0.GetPage(2).GridAdd(self.wxgui_numbersink2_0.win, 1, 1, 1, 1)
		self.plot_sink_0 = gnuradio.input.plot_sink.plot_sink_f(
			self.notebook_0.GetPage(1).GetWin(),
			title="Step Response",
			vlen=1,
			decim=1000,
			gsz=1000,
			zoom=0,
		)
		self.notebook_0.GetPage(1).Add(self.plot_sink_0.win)
		self.gr_null_source_0_0 = gr.null_source(gr.sizeof_float*1)
		self.gr_null_source_0 = gr.null_source(gr.sizeof_float*1)
		self.const_source_x_7 = gr.sig_source_f(0, gr.GR_CONST_WAVE, 0, 0, 1)
		self.const_source_x_5 = gr.sig_source_f(0, gr.GR_CONST_WAVE, 0, 0, variable_slider_5)
		self.const_source_x_4 = gr.sig_source_f(0, gr.GR_CONST_WAVE, 0, 0, variable_slider_4)
		self.const_source_x_3 = gr.sig_source_f(0, gr.GR_CONST_WAVE, 0, 0, variable_slider_3)
		self.const_source_x_2 = gr.sig_source_f(0, gr.GR_CONST_WAVE, 0, 0, variable_slider_2)
		self.const_source_x_1 = gr.sig_source_f(0, gr.GR_CONST_WAVE, 0, 0, variable_slider_1)
		self.const_source_x_0 = gr.sig_source_f(0, gr.GR_CONST_WAVE, 0, 0, variable_slider_0)
		self.Transfer_function_Response_0 = gnuradio.input.Response.Response(2,12,1,15,0.01)
		self.Transfer_function_Numerator_0 = gnuradio.input.Numerator.Numerator(2)
		self.Transfer_function_Denominator_0 = gnuradio.input.Denominator.Denominator(2)
		self.Max_val_0 = gnuradio.input.Max_val.Max_val(1,15,0.01)
		self.Calculation_Calculator_9 = gnuradio.input.Calculator.Calculator(1)
		self.Calculation_Calculator_9.set_parameters("100*exp((-a0*3.14)/(sqrt(1-(a0**2))))",1)
		self.Calculation_Calculator_8 = gnuradio.input.Calculator.Calculator(2)
		self.Calculation_Calculator_8.set_parameters("a0/(2*sqrt(a1))",2)
		self.Calculation_Calculator_7 = gnuradio.input.Calculator.Calculator(1)
		self.Calculation_Calculator_7.set_parameters("sqrt(a0)",1)
		self.Calculation_Calculator_6 = gnuradio.input.Calculator.Calculator(2)
		self.Calculation_Calculator_6.set_parameters("a0/a1",2)
		self.Calculation_Calculator_5 = gnuradio.input.Calculator.Calculator(6)
		self.Calculation_Calculator_5.set_parameters("(a3*a4)/((a0*((a1+a2)**(a3+1)))*a5)",6)
		self.Calculation_Calculator_4 = gnuradio.input.Calculator.Calculator(4)
		self.Calculation_Calculator_4.set_parameters("1.187*a0*((a2+a1)**a3)",4)
		self.Calculation_Calculator_3 = gnuradio.input.Calculator.Calculator(5)
		self.Calculation_Calculator_3.set_parameters("1/(((a0*((a2+a1)**a3)))*a4)",5)
		self.Calculation_Calculator_2 = gnuradio.input.Calculator.Calculator(2)
		self.Calculation_Calculator_2.set_parameters("a0/a1",2)
		self.Calculation_Calculator_1 = gnuradio.input.Calculator.Calculator(2)
		self.Calculation_Calculator_1.set_parameters("3.14/(a1*(sqrt(1 - (a0**2))))",2)
		self.Calculation_Calculator_0_0 = gnuradio.input.Calculator.Calculator(2)
		self.Calculation_Calculator_0_0.set_parameters("(4/((a1/(2*a0))*a0))",2)
		self.Calculation_Calculator_0 = gnuradio.input.Calculator.Calculator(2)
		self.Calculation_Calculator_0.set_parameters("((1.76*((a1/(2*a0))**3) - 0.417*((a1/(2*a0))**2) + 1.039*((a1/(2*a0))) + 1)/a0)",2)

		##################################################
		# Connections
		##################################################
		self.connect((self.Calculation_Calculator_0, 0), (self.wxgui_numbersink2_0, 0))
		self.connect((self.Calculation_Calculator_0_0, 0), (self.wxgui_numbersink2_0_1, 0))
		self.connect((self.Calculation_Calculator_2, 0), (self.Calculation_Calculator_0, 1))
		self.connect((self.const_source_x_0, 0), (self.Calculation_Calculator_3, 0))
		self.connect((self.const_source_x_1, 0), (self.Calculation_Calculator_3, 1))
		self.connect((self.const_source_x_4, 0), (self.Calculation_Calculator_3, 2))
		self.connect((self.const_source_x_5, 0), (self.Calculation_Calculator_3, 3))
		self.connect((self.const_source_x_2, 0), (self.Calculation_Calculator_3, 4))
		self.connect((self.const_source_x_0, 0), (self.Calculation_Calculator_4, 0))
		self.connect((self.const_source_x_1, 0), (self.Calculation_Calculator_4, 1))
		self.connect((self.const_source_x_4, 0), (self.Calculation_Calculator_4, 2))
		self.connect((self.const_source_x_5, 0), (self.Calculation_Calculator_4, 3))
		self.connect((self.const_source_x_0, 0), (self.Calculation_Calculator_5, 0))
		self.connect((self.const_source_x_1, 0), (self.Calculation_Calculator_5, 1))
		self.connect((self.const_source_x_4, 0), (self.Calculation_Calculator_5, 2))
		self.connect((self.const_source_x_5, 0), (self.Calculation_Calculator_5, 3))
		self.connect((self.Calculation_Calculator_4, 0), (self.Calculation_Calculator_5, 4))
		self.connect((self.const_source_x_2, 0), (self.Calculation_Calculator_5, 5))
		self.connect((self.Transfer_function_Response_0, 0), (self.plot_sink_0, 0))
		self.connect((self.Calculation_Calculator_5, 0), (self.wxgui_numbersink2_1, 0))
		self.connect((self.Calculation_Calculator_5, 0), (self.Transfer_function_Denominator_0, 0))
		self.connect((self.const_source_x_7, 0), (self.Transfer_function_Denominator_0, 2))
		self.connect((self.Calculation_Calculator_2, 0), (self.Transfer_function_Denominator_0, 1))
		self.connect((self.Calculation_Calculator_3, 0), (self.Transfer_function_Numerator_0, 0))
		self.connect((self.gr_null_source_0, 0), (self.Transfer_function_Numerator_0, 1))
		self.connect((self.gr_null_source_0_0, 0), (self.Transfer_function_Numerator_0, 2))
		self.connect((self.const_source_x_3, 0), (self.Calculation_Calculator_2, 0))
		self.connect((self.const_source_x_2, 0), (self.Calculation_Calculator_2, 1))
		self.connect((self.Calculation_Calculator_3, 0), (self.wxgui_numbersink2_0_5, 0))
		self.connect((self.Transfer_function_Numerator_0, 0), (self.Transfer_function_Response_0, 0))
		self.connect((self.Transfer_function_Denominator_0, 0), (self.Transfer_function_Response_0, 1))
		self.connect((self.Calculation_Calculator_2, 0), (self.Calculation_Calculator_0_0, 1))
		self.connect((self.Calculation_Calculator_7, 0), (self.Calculation_Calculator_0_0, 0))
		self.connect((self.Calculation_Calculator_6, 0), (self.wxgui_numbersink2_0_2, 0))
		self.connect((self.Calculation_Calculator_3, 0), (self.Calculation_Calculator_6, 0))
		self.connect((self.Calculation_Calculator_5, 0), (self.Calculation_Calculator_6, 1))
		self.connect((self.Calculation_Calculator_2, 0), (self.wxgui_numbersink2_3, 0))
		self.connect((self.Calculation_Calculator_2, 0), (self.Calculation_Calculator_8, 0))
		self.connect((self.Calculation_Calculator_5, 0), (self.Calculation_Calculator_8, 1))
		self.connect((self.Calculation_Calculator_8, 0), (self.Calculation_Calculator_9, 0))
		self.connect((self.Calculation_Calculator_9, 0), (self.wxgui_numbersink2_0_3, 0))
		self.connect((self.Calculation_Calculator_7, 0), (self.Calculation_Calculator_0, 0))
		self.connect((self.Calculation_Calculator_8, 0), (self.Calculation_Calculator_1, 0))
		self.connect((self.Calculation_Calculator_5, 0), (self.Calculation_Calculator_7, 0))
		self.connect((self.Calculation_Calculator_7, 0), (self.Calculation_Calculator_1, 1))
		self.connect((self.const_source_x_7, 0), (self.wxgui_numbersink2_2, 0))
		self.connect((self.Max_val_0, 0), (self.wxgui_numbersink2_0_4, 0))
		self.connect((self.Transfer_function_Response_0, 0), (self.Max_val_0, 0))
		self.connect((self.Calculation_Calculator_1, 0), (self.wxgui_numbersink2_0_0, 0))


	def get_variable_slider_5(self):
		return self.variable_slider_5

	def set_variable_slider_5(self, variable_slider_5):
		self.variable_slider_5 = variable_slider_5
		self.const_source_x_5.set_offset(self.variable_slider_5)
		self._variable_slider_5_slider.set_value(self.variable_slider_5)
		self._variable_slider_5_text_box.set_value(self.variable_slider_5)

	def get_variable_slider_4(self):
		return self.variable_slider_4

	def set_variable_slider_4(self, variable_slider_4):
		self.variable_slider_4 = variable_slider_4
		self.const_source_x_4.set_offset(self.variable_slider_4)
		self._variable_slider_4_slider.set_value(self.variable_slider_4)
		self._variable_slider_4_text_box.set_value(self.variable_slider_4)

	def get_variable_slider_3(self):
		return self.variable_slider_3

	def set_variable_slider_3(self, variable_slider_3):
		self.variable_slider_3 = variable_slider_3
		self.const_source_x_3.set_offset(self.variable_slider_3)
		self._variable_slider_3_slider.set_value(self.variable_slider_3)
		self._variable_slider_3_text_box.set_value(self.variable_slider_3)

	def get_variable_slider_2(self):
		return self.variable_slider_2

	def set_variable_slider_2(self, variable_slider_2):
		self.variable_slider_2 = variable_slider_2
		self.const_source_x_2.set_offset(self.variable_slider_2)
		self._variable_slider_2_slider.set_value(self.variable_slider_2)
		self._variable_slider_2_text_box.set_value(self.variable_slider_2)

	def get_variable_slider_1(self):
		return self.variable_slider_1

	def set_variable_slider_1(self, variable_slider_1):
		self.variable_slider_1 = variable_slider_1
		self.const_source_x_1.set_offset(self.variable_slider_1)
		self._variable_slider_1_slider.set_value(self.variable_slider_1)
		self._variable_slider_1_text_box.set_value(self.variable_slider_1)

	def get_variable_slider_0(self):
		return self.variable_slider_0

	def set_variable_slider_0(self, variable_slider_0):
		self.variable_slider_0 = variable_slider_0
		self.const_source_x_0.set_offset(self.variable_slider_0)
		self._variable_slider_0_slider.set_value(self.variable_slider_0)
		self._variable_slider_0_text_box.set_value(self.variable_slider_0)

	def get_samp_rate(self):
		return self.samp_rate

	def set_samp_rate(self, samp_rate):
		self.samp_rate = samp_rate

if __name__ == '__main__':
	parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
	(options, args) = parser.parse_args()
	tb = top_block()
	tb.Run(True)

